# jrh_n_calc.rb - Version 1.0 - (C) 2015 by Aqualung -- Permission granted to freely use this
# code as long as this line and the preceding line are included in any derivative work(s) JRH
#
# Given a radius, angle, and toloerance, this outputs the rounded up number of sides a circle
# approximation needs to stay within the specified tolerance.
#
# 2015.09.17 - Version 1.1 - The result is rounded up to nearest multiple of four to insure
# that the primary cardinal points are available (suggested by john_drivenupthewall and TIG)
#         
#
def jrh_n_calc()
  prompts = ["Radius ","Angle ","Tolerance ","Type "]
  defaults = ["1.00","360.0","0.025","Sagitta"]
  list = ["","","","Sagitta|Flat"]
  input = UI.inputbox prompts, defaults, list, "Enter N Calc Parameters:"
  if(input)
    radius = input[0].to_f
    scale = input[1].to_f / 360.0
    error = input[2].to_f
    type = input[3]
  end
  if(type == "Flat")
    n = scale * Math::PI / Math.asin(error / (2.0 * radius))
  else
    n = scale * Math::PI / Math.acos((radius - error) / radius)
  end
  n = (n + 1.0).to_i
  n4 = (n + 3) & 4294967292
  UI.messagebox("N = " + n.to_s + " (N%4 = " + n4.to_s + ")")
end
menu = UI.menu("PlugIns").add_item("N Calc") { jrh_n_calc }
